/* $Id: settingdefs.cpp,v 1.6 2005/06/28 13:55:23 chfreund Exp $ */

#include "settingdefs.hpp"

/**********************************************************/

// setting attributes
#define  SSSATTR  (Setting::COMMA_SEPARATED     | \
                   Setting::EXPLICIT_ASSIGNMENT | \
                   Setting::CONFIG_FILE_ONLY)
#define  SSSATTRM (SSSATTR | Setting::MANDATORY)

/**********************************************************/

// setting definitions (MUST be ordered like enums in class declaration)
const SettingDef SpriteSequenceSettingDefs::
m_SettingDef[SpriteSequenceSettingDefs::NUM_SETTING_DEFS+1] =
{
	SettingDef("frames"  , NULL, Setting::STRING, 1,  1, SSSATTRM),
	SettingDef("indices" , NULL, Setting::INT,    2,  2, SSSATTRM),
	SettingDef("colorkey", NULL, Setting::INT,    3,  3, SSSATTR ),
	SettingDef("alpha"   , NULL, Setting::INT,    1,  1, SSSATTR ),
	SettingDef("hotspot" , NULL, Setting::INT,    2,  2, SSSATTR ),
	SettingDef()
};

/**********************************************************/

// setting definitions (MUST be ordered like enums in class declaration)
const SettingDef SpriteSetSettingDefs::
m_SettingDef[SpriteSetSettingDefs::NUM_SETTING_DEFS+1] =
{
	// >>enter_section<< SET_PLAN
	//// defines the whole set as "color templated"
	SettingDef("templated", NULL, Setting::BOOL,   1,  1, SSSATTR ),
	//////// number of layers in the templated set
	SettingDef("nlayers",   NULL, Setting::INT,    1,  1, SSSATTR ),
	//////// switches on smoothing after templated building
	SettingDef("smooth",    NULL, Setting::REAL,  1,  1, SSSATTR ),
	//// sequences enumerated separately
	SettingDef("sequences", NULL, Setting::STRING, 1, -1, SSSATTR ),
	//// alternative definition of the sequences (probably not needed)
	SettingDef("seqformat", NULL, Setting::STRING, 1,  1, SSSATTR ),
	SettingDef("indices",   NULL, Setting::INT,    2,  2, SSSATTR ),
	//// definition of subdirectories
	SettingDef("subdirs",   NULL, Setting::STRING, 1, -1, SSSATTR ),
	SettingDef("subconf",   NULL, Setting::STRING, 1, -1, SSSATTR ),
	//// object ID for the sprite set
	SettingDef("objectID",  NULL, Setting::STRING, 1,  1, SSSATTR ),
	//// tolerance for grayscale judgement in coloring routine
	SettingDef("graytol",   NULL, Setting::INT,    1,  1, SSSATTR  ),
	// >>leave_section<< SET_PLAN
	SettingDef()
};

/**********************************************************/

const SettingDef WopSpriteSettingDefs::m_SettingDef[] =
{
	// pairs of relative (to the location, where this configuration file
	// is stored) paths of the directories, where the configuration files
	// for the sprite sets can be found AND the names of these configuration
	// files
	SettingDef( "pathconfigpairs", NULL, Setting::STRING, 2, -1,
	            Setting::COMMA_SEPARATED | Setting::EXPLICIT_ASSIGNMENT |
	            Setting::MANDATORY ),
	// empty setting definition terminating the setting definitions
	SettingDef()
};

/**********************************************************/
