/* $Id: version.cpp,v 1.1 2005/12/18 19:19:33 chfreund Exp $ */

#include "version.hpp"
#include <sstream>

std::string Version::getString() const {
	std::ostringstream str;
	str << static_cast<int>( major ) << "."
		<< static_cast<int>( minor ) << "."
		<< static_cast<int>( patch );
	return str.str();
}

void Version::serialize( Uint8*& bufferPointer ) const {
	Serialize<Uint8>::serialize( major, bufferPointer );
	Serialize<Uint8>::serialize( minor, bufferPointer );
	Serialize<Uint8>::serialize( patch, bufferPointer );
}

void Version::deserialize( Uint8*& bufferPointer ) {
	Serialize<Uint8>::deserialize( bufferPointer, major );
	Serialize<Uint8>::deserialize( bufferPointer, minor );
	Serialize<Uint8>::deserialize( bufferPointer, patch );
}

Version getWopVersion() {
	return Version( WOP_MAJOR_VERSION, WOP_MINOR_VERSION, WOP_PATCHLEVEL );
}
